#include<stdio.h>
#include<fcntl.h>
#include<stdlib.h>
#include<sys/stat.h>
#include<unistd.h>
#include<string.h>
#include<time.h>

#include "myfs.h"

inline int set_myfs_bit(int bitmap,int blockno){
				return (bitmap)|(1<<(blockno-1));
}

/*int bwrite(int dev, int block, int blocksize,char *buff){
				int nw;
				lseek(dev,block*blocksize,SEEK_SET);
	fprintf(stderr,"\nwriting on dev %d block %d data %s",dev,block,buff);
	

	if((nw=write(dev,buff,blocksize))!=blocksize)
	fprintf(stderr,"Could not write completely to the buffer\nWrote %d bytes out of %d\n",nw,blocksize);
	fprintf(stderr,"\n Number of bytes written %d",nw);
				return nw;
}

struct buffer_head * bread(int dev, int block, int blocksize){
		
				struct buffer_head *bh;
				if((bh=(struct buffer_head *)malloc(sizeof(*bh)))==NULL)
				return NULL;
				bh->b_data=(char *)malloc(blocksize);
				lseek(dev,block*blocksize,SEEK_SET);
				read(dev,bh->b_data,blocksize);
				bh->b_dev=dev;
				bh->b_size=blocksize;
				bh->b_blocknr=block;
				return bh;
}
void brelse(struct buffer_head *bh)
{
	free(bh->b_data);
	free(bh);
}



void create_root_inode(int dev,unsigned32 blockno,unsigned32 inode,unsigned32 blocksize){
				struct buffer_head *bh,*bh1;
				struct myfs_inode *root;
	
			        fprintf(stderr,"Writing root inode [%d] info in block [%d]\n",inode,blockno);
				bh=bread(dev,blockno,blocksize);
				if(!bh){
				fprintf(stderr,"Could not create root inode\n");
				exit(1);
				}
				root=(struct myfs_inode *)((char *)bh->b_data+inode*sizeof(*root));
			        fprintf(stderr,"Writing root inode [%d] info in block [%d]\n",inode,blockno);
				root->ino=inode;
				root->uid=root->gid=0;
				root->mode|=(S_IFDIR|S_IRUSR|S_IWUSR|S_IXUSR|S_IROTH|S_IXOTH|S_IRGRP|S_IXGRP);
				root->perm=0x0755;
				root->size=blocksize;
				root->block_no=blockno;
				root->links=2;
				fprintf(stderr," ");
				bwrite(dev,blockno,blocksize,bh->b_data);
				
				bh1=bread(dev,blockno,blocksize);
				if(!bh1){
				fprintf(stderr,"Could not READ root inode\n");
				exit(1);
				}
				root=(struct myfs_inode *)((char *)bh1->b_data+inode*sizeof(*root));
				fprintf(stderr,"root->block_no %d",root->block_no);	
				fprintf(stderr,"root->links %d",root->links);	
				

				return;
}*/


void myfs_create(char * filename,unsigned int bs){
//	struct myfs_filesys *fs;
	int fd;
	struct myfs_super_block *msb;
	//struct buffer_head *bh,*bh1;
	struct myfs_inode *root;
	//char  * inode_addr;
	//char * name_str;
	struct myfs_dir_entry mde,mde1; 
	time_t tm;

	if(bs<=0 || bs>4096){
		fprintf(stderr,"Either invalid blocksize or too big for MYFS !!..setting to default [%d]\n",MYFS_DEFAULT_BS);
		bs=MYFS_DEFAULT_BS;
	}
	fd=open(filename,O_WRONLY);
	if(fd<0){
		perror("Cannot open device");
		exit(fd);
	}
	fprintf(stderr,"Writing super block info in block [%d]\n",MYFS_SUPER_BLOCK);

	msb=(struct myfs_super_block*)malloc(sizeof(struct myfs_super_block)); 	
	memset(msb,0,sizeof(struct myfs_super_block));
	msb->s_magic=MYFS_SUPER_MAGIC;
	set_myfs_bit(msb->block_bmp,1);
	set_myfs_bit(msb->inode_bmp,MYFS_ROOT_INO);
	msb->block_size= bs;
	msb->root_inode = MYFS_ROOT_INO;
	msb->total_blocks =  msb->total_inodes = sizeof(unsigned32)*8;
	msb->free_blocks = (8*(sizeof(unsigned32)))-1;
	msb->first_data_block = MYFS_ROOT_BLOCK;
	

	if(write(fd,msb,sizeof(struct myfs_super_block)) < sizeof(struct myfs_super_block)){
		free(msb);
		close(fd);
		printf("Could Not write super block");
		exit(-1);

	}



	/*CREATING ROOT INODE ---*/
	root = (struct myfs_inode *)malloc(sizeof(struct myfs_inode));
	memset(root,0,sizeof(struct myfs_inode));
	

	root->ino= MYFS_ROOT_INO;
	root->block_no = MYFS_ROOT_INO +1;  
	root->uid=root->gid=0;
	root->filetype = MYFS_DIR;
	root->perm=0x0764;
	root->size=bs;
	time(&tm);
	root->atime.tv_sec = root->mtime.tv_sec = root->ctime.tv_sec = tm;
	root->magic = MYFS_SUPER_MAGIC;
	lseek(fd,(bs*MYFS_INODE_BLOCK),SEEK_SET);
	if(write(fd,root,sizeof(struct myfs_inode)) < sizeof(struct myfs_inode)){
		printf("Could not write root inode");
		free(root);
		close(fd);
		return ;
	}




	/*CREATING ROOT DIRECTORY ENTRIES ---*/


	
	memset(&mde,0,sizeof(struct myfs_dir_entry));
	mde.ino=MYFS_ROOT_INO;
	strcpy(mde.name,".");
	mde.name_len=strlen(".");
	mde.rec_len = sizeof(struct myfs_dir_entry);
	
	
	memset(&mde1,0,sizeof(struct myfs_dir_entry));
	mde1.ino=MYFS_ROOT_INO;
	strcpy(mde1.name,"..");
	mde1.name_len=strlen("..");
	mde1.rec_len = sizeof(struct myfs_dir_entry);
	
	lseek(fd,(bs*MYFS_ROOT_BLOCK),SEEK_SET);
	if(write(fd,&mde,sizeof(struct myfs_dir_entry)) < sizeof(struct myfs_dir_entry)){
		printf("Could not write . dir entry");
		close(fd);
		return ;
	}
	if(write(fd,&mde1,sizeof(struct myfs_dir_entry)) < sizeof(struct myfs_dir_entry)){
		printf("Could not write .. dir entry");
		close(fd);
		return ;
	}
	
	fprintf(stderr,"MYFS filesystem created successfully\n");
	close(fd);
	return;
}//myfs_create


